SystemOrganization addCategory: #TpObjetos!

Object subclass: #Alumnos
	instanceVariableNames: 'atencion motivacion animo temasAprendidos temasImprescindibles calificacion'
	classVariableNames: 'Estados'
	poolDictionaries: ''
	category: 'TpObjetos'!

Alumnos class
	instanceVariableNames: 'atencion motivacion animo temasAprendidos calificacion'!

Alumnos class
	instanceVariableNames: 'atencion motivacion animo temasAprendidos calificacion'!

!Alumnos class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 05:29'!
iniciarEstados
Estados := OrderedCollection new.
Estados add: 'me quiero ir'.
Estados add: 'mas o menos'.
Estados add: 'todo bien'.
Estados add: 'con ganas de ser ayudante'.! !

!Alumnos class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 05:29'!
mostrarEstados
^Estados.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 01:07'!
animar
(Alumnos mostrarEstados isNil) ifTrue: [Alumnos iniciarEstados].
(animo isNil) 	ifTrue: [self animo: (Estados at: 1)]
				ifFalse: [(animo = (Estados at: 1)) ifTrue: [self animo: (Estados at: 2)]
				ifFalse: [(animo =(Estados at:2)) ifTrue: [self animo: (Estados at: 3)]
				ifFalse: [(animo = (Estados at:3)) ifTrue: [self animo: (Estados at: 4)]]]].! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
animo
^animo.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/20/2012 03:18'!
animo: unEstado
animo := unEstado.! !

!Alumnos methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 01:08'!
aprender: unTema
(temasAprendidos isNil) ifTrue: [	temasAprendidos := Set new.
									temasImprescindibles := Set new].
(unTema complejo)
	 ifTrue: [((atencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (atencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
	ifFalse: [((unTema estado = animo) & (atencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (atencion + 10).
					self motivar.
					self animar]].! !

!Alumnos methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 01:09'!
aprenderImprescindible: unTema
(temasAprendidos isNil) ifTrue: [temasAprendidos := Set new].
(temasImprescindibles isNil) ifTrue: [temasImprescindibles := Set new].
(unTema complejo)
	 ifTrue: [((atencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (atencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
	ifFalse: [((unTema estado = animo) & (atencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (atencion + 10).
					self motivar.
					self animar]].! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
atencion
^atencion.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/24/2012 21:20'!
atencion: unNumero
(unNumero >100) ifTrue: [atencion := 100]
ifFalse: [atencion := unNumero].! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:00'!
calificacion
^calificacion.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 19:17'!
calificacion: unNumero
(unNumero >= 4) 	ifTrue: [calificacion := unNumero]
					ifFalse: [calificacion := 2].! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 01:07'!
desanimar
(Alumnos mostrarEstados isNil) ifTrue: [Alumnos iniciarEstados].
(animo isNil) 	ifTrue: [self animo: (Estados at: 1)].
(animo = (Estados at: 4)) ifTrue: [self animo: (Estados at: 3)]
				ifFalse: [(animo =(Estados at:3)) ifTrue: [self animo: (Estados at: 2)]
				ifFalse: [(animo = (Estados at:2)) ifTrue: [self animo: (Estados at: 1)]]].! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
desmotivar
motivacion := false.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
invertirMotivacion
(motivacion) ifTrue: [self desmotivar] ifFalse:[self motivar].! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
motivacion
^motivacion.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
motivar
motivacion := true.! !

!Alumnos methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 03:44'!
new
^super new initialize! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 06:34'!
temas
^temasAprendidos.! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:11'!
temasAprendidos
^temasAprendidos.! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 20:02'!
temasImprescindibles
^temasImprescindibles.! !

Object subclass: #Docente
	instanceVariableNames: 'curso temasTotales temasVistos temasVistosMasDeDosVeces temasImprescindibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Docente class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/25/2012 00:26'!
nuevo
| unDocente |

unDocente := self new.
unDocente comenzarCurso.
^unDocente.! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 04:54'!
analogia
curso do: [:unAlumno | 
	((unAlumno atencion) > 30) 
		ifTrue:
		[unAlumno atencion: ((unAlumno atencion) +10).
		unAlumno motivar]
		
		ifFalse: [unAlumno desanimar]].! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 03:08'!
aprobados
| aprobados |

aprobados := (curso select: [:alum | alum calificacion >=4])size.
(curso size >0) ifTrue: [^aprobados/(curso size)].! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 9/24/2012 21:17'!
comenzarCurso
curso := Set new.
temasTotales := Set new.
temasVistos := Bag new.
temasVistosMasDeDosVeces := Set new.
temasImprescindibles := Set new.! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:57'!
curso
^curso.! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 19:59'!
darTema: unTema
curso do: [:unAlumno| unAlumno aprender: unTema].
temasTotales add: unTema.
temasVistos add: unTema.
((temasVistos occurrencesOf: unTema) >1) ifTrue: [temasVistosMasDeDosVeces add: unTema].
! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 19:59'!
darTemaImprescindible: unTema
curso do: [:unAlumno| unAlumno aprenderImprescindible: unTema].
temasTotales add: unTema.
temasVistos add: unTema.
temasImprescindibles add: unTema.

((temasVistos occurrencesOf: unTema) >1) ifTrue: [temasVistosMasDeDosVeces add: unTema].
! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 20:05'!
evaluar
	| materias totales |

totales := (temasTotales size).
curso do: [:unAlumno | materias := (unAlumno temasAprendidos size).
			((unAlumno temasImprescindibles size ) = (temasImprescindibles size)) ifTrue: 
			[unAlumno calificacion: (( materias / totales ) * 10)]
	
			ifFalse: [unAlumno calificacion: 2]].! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:53'!
inscribir: unAlumno
curso add: unAlumno.! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 06:01'!
payasada
curso do: [:unAlumno |
	unAlumno atencion: ((unAlumno atencion) *2).
	unAlumno invertirMotivacion.
	((unAlumno animo) = 'con ganas de ser ayudante') ifTrue: [unAlumno animo: 'me quiero ir']
	ifFalse: [unAlumno animar]].
! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 01:01'!
receso: unTiempo
curso do: [:unAlumno | 
			unAlumno atencion:  ((unAlumno atencion) + unTiempo).
			(((unAlumno animo) = 'me quiero ir' | (unAlumno animo) = 'mas o menos') & ((unAlumno atencion) < 50)) 
			ifTrue: [unAlumno atencion: ((unAlumno atencion) *2)]
			ifFalse: [unAlumno animar]].! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 06:57'!
repetidos
^temasVistosMasDeDosVeces  size.! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 03:06'!
temaMenosAprendido
| ordenados |

ordenados := temasTotales asSortedCollection: [:a :b | (curso inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (curso inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 03:05'!
temaMenosAprendidoMuchasVeces
| ordenados |

ordenados := temasVistosMasDeDosVeces asSortedCollection: [:a :b | (curso inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (curso inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:15'!
temasTotales
^temasTotales.! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:09'!
temasVistos
^temasVistos.! !

Object subclass: #Temas
	instanceVariableNames: 'nombre complejo interes estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Temas class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/25/2012 02:28'!
new: unNombre
|tema|

tema := Temas new.
tema nombre: unNombre.
^tema.! !

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 06:23'!
complejo
^complejo.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 06:23'!
esComplejo
complejo := true.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 01:21'!
esSimple
complejo := false.! !

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
estado
^estado.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:20'!
estado: algo
estado := algo.! !

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
interes
^interes.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:19'!
interes: unNumero
interes := unNumero.! !

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre
^nombre.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre: unNombre
nombre := unNombre .! !
